
#include "drill.h"

/* *********************

		updateTile

  will update sticked tag of the wanted one tile, and of his 4 acoled tiles.

********************* */

void removeFallList(struct fallObj *o)
{	o->stopFallNb = 0;
}

void addToStopFallList(struct fallObj * o, u32 id)
{	for(u32 n=0;n<o->stopFallNb;n++) if(id == o->stopFall[n]) return;
	o->stopFall[o->stopFallNb] = id;
	o->stopFallNb += 1;
}

u32 isInStopFallList(struct fallObj * o, u32 id)
{	for(u32 n=0;n<o->stopFallNb;n++) if(id == o->stopFall[n]) return 1;
	return 0;
}

void drillMap::createFallList(struct fallObj * o)
{	o->stopFallNb = 0;

	// first thing, test the first down tile of all object colon and see if there is anything under

//	if(o->nb >= 8)
/*	{
		u32 canDirectDown = 1;
		for(u32 x=0;x<o->sx;x++) // for eatch object colon
			{	u32 xx1 = x*o->sy; u32 xx2 = o->px+x;
				
				for(int y=o->sy-1;y >= 0;y--)
				 {	if(o->map[y+xx1] < 0xf0)
					{	u32 yy = (o->py+y+1)*tileSize+o->subPy;
						if	(	isAnyFallingBlocAt(xx2,yy)
							 ||	isAnyFallingBlocAt(xx2,yy+1)
							 ||	isAnyFallingBlocAt(xx2,yy+2)
							 ||	isAnyFallingBlocAt(xx2,yy+3)
							 ||	isAnyFallingBlocAt(xx2,yy+4)
							 ||	isAnyFallingBlocAt(xx2,yy+5)
							)		canDirectDown = 0;
						y = -1;
					}
				 };
			};

		if(canDirectDown) return;
	}*/

	for(u32 x=0;x<o->sx;x++) // for eatch object colon
		{	u32 xx1 = x*o->sy; u32 xx2 = o->px+x;
			
			for(int y=o->sy-1;y >= 0;y--)
			 {	if(o->map[y+xx1] < 0xf0)
				{	u32 objId = isAnyFallingBlocAt(xx2,(o->py+y+1)*tileSize+o->subPy);

					if(objId != 0xff && objId != o->id)
						addToStopFallList(o,objId);
				}
			 };
		};
}

void drillMap::downObject(struct fallObj * o)
{	if(o->canDown == 0) return;
	
	o->subPy++;
	
	if(o->subPy >= tileSize) // we reatch a new tile line
	{	o->subPy = 0;
		if(o->py++ >= (u32)sizey)	{ removeObj(o); return ; }

		// see if can stick to the map
		u32 stickHere=0;

		for(u32 xx=0;xx<o->sx && !stickHere;xx++)
			for(u32 yy=0;yy<o->sy && !stickHere;yy++)
			{	if(o->map[xx*o->sy+yy]<0xf0) // if filled
				{	int x = o->px + xx;
					int y = o->py + yy;

					// check left of tile
					 if(getColor(x-1,y) == o->color)	stickHere = 1;
					
					// check right of tile
					 if(getColor(x+1,y) == o->color)	stickHere = 1;

					// check down of tile
					 if(this->isThereATile(x,y+1)) stickHere = 1;
				}
			};

			if(stickHere)
			{	for(u32 xx=0;xx<o->sx;xx++)
					for(u32 yy=0;yy<o->sy;yy++)
					{	if(o->map[xx*o->sy+yy]<0xf0)
						{	array[(o->px+xx)*sizey+(o->py+yy)] = o->map[xx*o->sy+yy];
						}
					};

				removeObj(o);
				this->update();
			}
		
	}
}

 // coordonate for up, down, left and right
static int waypos[8] = { 0,-1,  0,1,  -1,0,  1,0 };

 // up->down, left to right and ... :)
static int wayInvert[4] = { 1,0,3,2 };

void drillMap::removeObj(struct fallObj *o)
{	if(o->map) free(o->map);
	u32 id = o->id;
	memset(o,0,sizeof(struct fallObj));
	o->id = id;
	this->objfill -- ;
}


u32 boxColide(u32 x1,u32 y1,u32 x2,u32 y2,u32 sx1,u32 sx2,u32 sy1, u32 sy2)
{ //int sx1=*s1++, sy1=*s1++ ;
  //int sx2=*s2++, sy2=*s2++ ;

  if(x2<=x1+sx1 && x2+sx2>=x1)
   if(y2<=y1+sy1 && y2+sy2>=y1)
		return 1 ;
  return 0 ;
}

u32 drillMap::drillColide(struct fallObj *o1,struct fallObj *o2)
{	u8 *s1 = o1->map;
	int x1 = o1->px;
	int y1 = o1->py;
	u8 *s2 = o2->map;
	int x2 = o2->px;
	int y2 = o2->py;
	int sx1= o1->sx;
	int sy1= o1->sy;
	int sx2= o2->sx;
	int sy2= o2->sy;

	// does the object border colide ?
  if(x2<=x1+sx1 && x2+sx2>=x1)
   if(y2<=y1+sy1 && y2+sy2>=y1)
    {	// yes thes does, now test eatch sub block with eatch other..
	    int spr1x=0,spr2x=0,szx ;
        // compute the colide box
		if(x1 < x2) spr1x = x2 - x1 ;
		else if(x2 < x1) spr2x = x1 - x2 ;
			
		if(x1 + sx1 >= x2 + sx2)
		{	if(x1 > x2) szx = (x2 + sx2) - x1 ;
			 else szx = sx2 ;
		} else if(x1 + sx1 < x2 + sx2) szx = (x1 + sx1) - x2 ;
			
		if(szx > sx1) szx=sx1 ;

		for(int ox1=spr1x ; ox1<szx+spr1x ; ox1++)
			for(u32 oy1=0 ; oy1<o1->sy    ; oy1++)
			{	if(s1[ox1*sx1+oy1]<0xf0)
				{	// this tile is fill, test colide with all other filled tiles of object2
					for(int ox2=spr2x ; ox2<szx+spr2x   ; ox2++)
						for(u32 oy2=0 ; oy2<o2->sy      ; oy2++)
						{	if(s2[ox1*sx1+oy1]<0xf0)
							{ if(boxColide	(	ox1, oy1*tileSize+o1->subPy,
												ox2, oy2*tileSize+o2->subPy,
												tileSize,tileSize,tileSize,tileSize
											)
								) return 0;
							}
						};

				}

			};
    }  return 0 ;
}

/*
u32 drillMap::zcanObjectFallDown(struct fallObj *o)
{	
	struct fallObj * p = &obj[0];
	
	for(u32 n=0;n<objfill && n<1024;o++)
	{	
	   if(p == o) n++;
	   else
		if(p->state) // object is enable (rumble or fall)
		{
			if(drillColide(o,p)) return 0;

			n++;
		}	p++;
	};
	
	return 1;

}*/

u32 drillMap::isAnyFallingBlocAt(u32 colon, u32 y)
{	u32 off = colon*sizey*tileSize + y;
	return arrayFill[off];
}

u32 drillMap::isFallingBlocAt(u32 colon, u32 y)
{	u32 off = colon*sizey*tileSize + y;
	u32 n = arrayFill[off];
	if(n==0xff) return 0;
	return 1;
}

/*
u32 drillMap::_canObjectFallDown(struct fallObj *o)
{	fallingBlockParsed[o->id] = 1;

	if(o->state == 2)
		{	u32 objCanDown = 1;
			
			for(u32 x=0;x<o->sx && objCanDown;x++) // for eatch object colon
			{ u32 xx1 = x*o->sy; u32 xx2 = o->px+x;
			 for(int y=o->sy-1;y >= 0 && objCanDown;y--)
			 {	if(o->map[y+xx1] < 0xf0)
				{	// there is a block, test if it can down
					u32 objId = isAnyFallingBlocAt(xx2,(o->py+y+1)*tileSize+o->subPy);
					
					if(objId && !fallingBlockParsed[objId])
						{	// test if the block 
							
						}
					  else	                                     
						{	objCanDown = 0;
						
						}

					y = -1; // only test the first down block and switch to other colon
				}
			 };
			};
		}



}*/

u32 drillMap::canObjectFallDown(struct fallObj *o)
{
	memset(fallingBlockParsed,0,fallingBlockNb);

		if(o->state == 2)
		{	u32 objCanDown = 1;
			
			for(u32 x=0;x<o->sx && objCanDown;x++) // for eatch object colon
			{ u32 xx1 = x*o->sy; u32 xx2 = o->px+x;
			 for(int y=o->sy-1;y >= 0 && objCanDown;y--)
			 {	if(o->map[y+xx1] < 0xf0)
				{	// there is a block, test is it can down
					u32 canDown = isAnyFallingBlocAt(xx2,(o->py+y+1)*tileSize+o->subPy);
					if(canDown)	objCanDown = 0;
					y = -1; // only test the first down block and switch to other colon
				}
			 };
			};
		}

		return 0;
}

/*u32 drillMap::rIsFallObjFall(struct fallObj * o)
{	if(o->parsed) return o->canDown;

	o->parsed = 1;	o->canDown = 1;

	for(u32 z=0;z<o->stopFallNb;z++)
	{	u32 id = o->stopFall[z];
		struct fallObj * ob = &obj[id];

		if(!ob->parsed)	rIsFallObjFall(ob);
		
		o->canDown = ob->canDown;
		
		if(!o->canDown) return 0;
	};
	
	return 1;
}

*/

			
			/*	for(n=0;n<objWhoDown;n++)
					{	struct fallObj * ptr = objToDown[n];
						ptr->parsed = 0;
					};
				
					rIsFallObjFall(o);*/
/*
					o->canDown = 1;

					for(u32 x=0;x<o->sx;x++) // for eatch object colon
						{
							u32 xx1 = x*o->sy; u32 xx2 = o->px+x;
							
							for(int y=o->sy-1;y >= 0;y--)
							 {	
								if(o->map[y+xx1] < 0xf0)
								{	
									u32 yy = (o->py+y+1)*tileSize+o->subPy;
									
									if	(	isFallingBlocAt(xx2,yy)
										 ||	isFallingBlocAt(xx2,yy+1)
										 ||	isFallingBlocAt(xx2,yy+2)
										 ||	isFallingBlocAt(xx2,yy+3)
										 ||	isFallingBlocAt(xx2,yy+4)
										 ||	isFallingBlocAt(xx2,yy+5)
										)		o->canDown = 0;
									
									y = -1;
								}

							 };

						};

					//if(canDirectDown) return;

*/



u32 drillMap::rIsFallObjFall(u32 id)
{	struct fallObj * o = &obj[id];
	if(o->parsed) return o->canDown;

	o->parsed = 1;	o->canDown = 1;

	for(u32 z=0;z<o->stopFallNb;z++)
	{	u32 subid = o->stopFall[z];
		struct fallObj * subObj = &obj[subid];

		if(!subObj->parsed)	rIsFallObjFall(subid);
		if(!subObj->canDown) o->canDown = 0;
	};
	
	return o->canDown;
}

void drillMap::drawAndUpdateObj(void)
{	if(!objfill) return;
	struct fallObj * objToDown[512];
	struct fallObj * objToRumble[512];
	u32 objWhoDown = 0;
	u32 objWhoRumble= 0;
	memset(arrayFill,0xff,sizey*tileSize*sizex);

	u32 fallingBlockNb = 0;

	struct fallObj * o = &obj[0];
	u32 count = objfill;
	for(u32 n=0;n<count;o++)
	{	//o->stopFallNb = 0;
		o->canDown = 1;
		o->parsed = 0;

		if(o->state) // object is enable
		{	
			if(o->state == 2)	// fall
			{
				for(u32 x=0;x<o->sx;x++)
					for(u32 y=0;y<o->sy;y++)
						if(o->map[y+x*o->sy] < 0xf0)
						{	u32 xx = (x+o->px);
							u32 yy = (y+o->py);
							drawGfm	(	tileset[o->map[y+x*o->sy]],
										xx*tileSize,
										yy*tileSize + o->subPy
									);
							u32 off = xx*sizey*tileSize + yy*tileSize + o->subPy;
							memset(&arrayFill[off],o->id,tileSize);
						}
				
				objToDown[objWhoDown++] = o;
			}
				else	// rumble
			{					
				if(o->lastTime[0] + 1000 <= tick) o->state = 2;
				if(o->lastTime[1] + 40 <= tick)
				{	o->rumble = (rand()%2)-1;
					o->lastTime[1] = tick;
				}

				objToRumble[objWhoRumble++] = o;

				for(u32 x=0;x<o->sx;x++)
					for(u32 y=0;y<o->sy;y++)
					{	if(o->map[y+x*o->sy] < 0xf0)
						{	u32 tileValue = o->map[y+x*o->sy];
							u32 xx = (x+o->px);
							u32 yy = (y+o->py);
							drawGfm	(	tileset[tileValue],
										xx*tileSize + o->rumble,
										yy*tileSize
									);
							u32 off = xx*sizey*tileSize + yy*tileSize;
							memset(&arrayFill[off],o->id,tileSize);
						}
					};
					
			}

			n++;
		}
	};

	for(u32 pawa=0;pawa<=2;pawa++) // not refresh arrayFill at eatch down session work fine and made a cool not direct down effect :)
	{

	// create stop fall list for eatch falling objects

		for(n=0;n<objWhoDown;n++)
		{	struct fallObj * o = objToDown[n];
			createFallList(o);
		};

	// test all falling object to see if they really down

		for(n=0;n<objWhoDown;n++)
		{	struct fallObj * o = objToDown[n];
			o->canDown = 1;
			
			for(u32 z=0 ; z<o->stopFallNb && o->canDown; z++)
			{	struct fallObj * ob = &obj[o->stopFall[z]];
				if(!isInStopFallList(ob,o->id))
					{	/*for(u32 zz=0 ; zz<ob->stopFallNb && o->canDown; zz++)
						{	struct fallObj * obb = &obj[ob->stopFall[zz]];
							if(!isInStopFallList(obb,ob->id))
								if(!isInStopFallList(obb,o->id))*/
									o->canDown = 0;
						//};
					}
			};

/*
			if(o->canDown)
			{	o->parsed = 1;
			} else o->parsed = 0;*/
		};

//	if(!doesObjDown && objWhoDown)
		for(n=0;n<objWhoDown;n++)
		{	
			/*for(u32 z=0;z<objWhoDown;z++)
			{	struct fallObj * ob = objToDown[z];
				ob->parsed = ob->canDown;
			}
			
			struct fallObj * o = objToDown[n];
			if(!o->canDown) rIsFallObjFall(o->id);*/

			struct fallObj * o = objToDown[n];
//			o->canDown = 1;

		};

	// now down them..

		for(n=0;n<objWhoDown;n++)
		{	struct fallObj * o = objToDown[n];
			downObject(o);
		};

	};
}


drillMap::drillMap(void)
{	scrollx = scrolly = objfill = destructNb = 0;
	sizex = 9; sizey = 100; tileSize = 32;
	for(u32 n=0 ; n<1024 ; n++)
	{	memset(&(obj[n]),0,sizeof(struct fallObj));
		obj[n].id = n;
	};
	arrayFill = (u8*)malloc(sizex*sizey*tileSize);
	fallingBlockParsed = array+2048;
}


void drillMap::updateTile(int x, int y)
{	u32 color = getColor(x,y);
	if(color >= 0xf0) return; // current tile is out of map

  // test value of eatch 4 border tiles and change them if need

	for(u32 way=0 ; way<4 ; way++)
	{	int xx = x + waypos[2*way];
		int yy = y + waypos[2*way+1];
		u32 color2 = getColor(xx,yy);
		if(color2 != 0xff) // tile 2 is in map
		{	u32 sticked = (color == color2); // are the tiles sticked ?
			setStick(x,y,way,sticked); // update current tile
			setStick(xx,yy,wayInvert[way],sticked); // and the border
		} else setStick(x,y,way,0); // tile 2 out of map, set current as not sticked
	}
}

u32  drillMap::isThereATile(int x, int y)
{	if(x<0 || x>=sizex)  return 0;
	if(y<0 || y>=sizey) return 0;
	
	return (array[y+x*sizey] < 0xf0) ;
}

u32  drillMap::getStick(int x, int y)
{	if(x<0 || x>=sizex)  return 0xff;
	if(y<0 || y>=sizey) return 0xff;

	return (array[y+x*sizey])&0xf;

}

void drillMap::setStick(int x, int y, u32 way, u32 value)
{	if(x<0 || x>=sizex)  return;
	if(y<0 || y>=sizey) return;

	if(value) // set bit as 1
	{	u32 z = array[y+x*sizey];
		u32 c = z >> 4;
		u32 s = z&0xf;
		s |= (1<<way);
		array[y+x*sizey] = (c<<4) | s;
		return;
	}
	
	// set bit as 0
	u32 z = array[y+x*sizey];
	u32 c = z >> 4;
	u32 s = z&0xf; s = ~s;
	s |= (1<<way);  s = ~s;
	array[y+x*sizey] = (c<<4) | s;
}

u32 drillMap::isOutOfMap(int x, int y)
{	if(x<0 || x>=sizex)  return 1;
	if(y<0 || y>=sizey) return 1;
	return 0;
}

u32  drillMap::getColor(int x, int y)
{	if(x<0 || x>=sizex)  return 0xf0;
	if(y<0 || y>=sizey) return 0xf0;

	return (array[y+x*sizey])>>4;
}

void drillMap::setColor(int x, int y, u32 value)
{	if(x<0 || x>=sizex)  return;
	if(y<0 || y>=sizey) return;
	if(value > 0xf)  return;

	u32 z = array[y+x*sizey];
	u32 s = z&0xf;
	array[y+x*sizey] = (value<<4) | s;
}

void drillMap::randomize(void)
{	srand(GetTickCount());
	memset(array,0,1024);
	for(int x=0;x<sizex;x++)
		for(int y=0;y<sizey;y++)
			setColor(x,y,rand()%4);
	update();
}

void drillMap::set(int x, int y, u32 value)
{	if(x<0 || x>=sizex)  return;
	if(y<0 || y>=sizey) return;
	if(value > 255) return;

	array[y+x*sizey] = value;
}

void drillMap::showOne(int x, int y)
{	if(x<0 || x>=sizex)  return;
	if(y<0 || y>=sizey) return;

	u32 z = array[y+x*sizey];
	u32 s = z & 0x0f;
	u32 c = z >> 4;

	printlr("%i.%i : 0x%X -- stick %i, color %i",x,y,z,s,c);
}

void drillMap::draw(void)
{	for(int x=0; x<sizex; x++)
	 for(u32 y=0; y<16; y++)
	 { 	u32 tile = array[y+x*sizey];
		if(tile < 16*4) drawGfm(tileset[tile],x<<5,y<<5);
	 };

	 prints(-1,2,".%i.",objfill);
}

void drillMap::update(void)
{	for(int x=0; x<sizex; x++)
	 for(int y=0; y<sizey; y++)
	  updateTile(x,y);
}

void drillMap::deleteThisBlock(int x, int y)
{	destruct(x,y);
	printlr("searchForFallingBlock(%i)",lineMax);
	searchForFallingBlock(lineMax);
}
 
void drillMap::destruct(int x, int y)
{	destructNb = 0;
	lineMax = colMax = 0;
	lineMin = colMin = 255;

	printlr("destruct at block %i.%i",x,y);
	deleteBlock(x,y);
	printlr("deleted %i block.",destructNb);
}

void drillMap::deleteBlock(int x, int y)
{	if(x<0 || x>=sizex)  return;
	if(y<0 || y>=sizey) return;
	
	if(array[y+x*sizey] >= 0xf0) // already deleted, or empty..
	{	printlr("** delete error on block %i.%i (0x%X)",x,y,array[y+x*sizey]);
		array[y+x*sizey] = 0xf0;
		//while(!keyArray[kctrl]) Gdl_flip();
		return;
	}

	if(x < colMin)   colMin = x;
	if(x > colMax)   colMax = x;
	if(y < lineMin) lineMin = y;
	if(y > lineMax) lineMax = y;

//	printlr(" -- destruct (%i) at %i.%i (0x%X)",destructNb,x,y,array[y+x*sizey]);


	//	setColor(x,y,15);

	destructList[destructNb*4]   = x;
	destructList[destructNb*4+1] = y;
	destructList[destructNb*4+2] = array[y+x*sizey];
	destructNb++;

	u32 stick = (array[y+x*sizey])&0xf;
	array[y+x*sizey] = 0xf0; // delete tile

	if(!stick) return;

//printlr("sticked! 0x%x",stick);

	// else, tile is sticked to another, delete them

	for(u32 way=0 ; way<4 ; way++) // for eatch way
	{	if((stick>>way)&1) // this way is sticked!
			{	// tag the tile as not sticked on this border
				int xx = x + waypos[2*way];
				int yy = y + waypos[2*way+1];
				//setStick(xx,yy,wayInvert[way],0);
				//printlr("relaunch on %i.%i",xx,yy);
				deleteBlock(xx,yy);
			}
	}
}

u32 drillMap::getValue(int x, int y)
{	if(x<0 || x>=sizex)  return 0xffff;
	if(y<0 || y>=sizey) return 0xffff;

	return array[y+x*sizey];
}

u32 drillMap::isAnyBlockUnder(int x, int y)
{ return isThereATile(x,y+1); }

u32 drillMap::blockCanFall(int x, int y)
{	u32 canFall = 1;
	memset(array+1024,0,1024);
	rBlockCanFall(x,y,&canFall);
	return canFall;
}

void drillMap::rBlockCanFall(int x, int y, u32*canFall)
{	if(!*canFall) return; // cannot fall, no need to search anymore

	if(isOutOfMap(x,y)) return;	// out of map.. return

	if(array[1024+y+x*sizey]) return; // if we already scan this block, return

	array[1024+y+x*sizey] = 1; // set block as scanned

	if(array[y+x*sizey] >= 0xf0)
		{	*canFall = 0;
		return;
	}

	if(isOutOfMap(x,y+1)) // at down of map, block cannot fall..
	{	*canFall = 0;
		return;
	}

	u32 color  = array[y+x*sizey]>>4;   // color of current block
	u32 color2 = array[y+1+x*sizey]>>4; // and of block under the current
	
	if(color2 != 0xf && color2 != color) // if there is a != tile under the current, test him recursivily to see if it can fall
	{	rBlockCanFall(x,y+1,canFall);
		if(!*canFall) return;
	} // test if current block can fall or not

	// if here, the tile can fall, now test all acoled tiles in a recursive way..

	u32 stick = getStick(x,y);
	for(u32 way=0 ; way<4 ; way++) // for eatch way
	{	if((stick>>way)&1) // this way is sticked!
			{	int xx = x + waypos[2*way];
				int yy = y + waypos[2*way+1];
				rBlockCanFall(xx,yy,canFall);
				if(!*canFall) return;
			}
	}
}

void drillMap::searchForFallingBlock(u32 line)
{	while(1)
	{	//printl(" * line %i ",line);
		for(int x=0;x<sizex;x++)
		{//	printl("%i ",x);
			if(isThereATile(x,line))
			{	//printlr("tile found %i.%i",x,line);
				if(blockCanFall(x,line))
				{	//printl("block can fall! (%i.%i)\n",x,line);
					deleteAndAddToFallObj(x,line);
				}
			}
		};
		//printlr("");
		if(!line--) return;
	};
}

void drillMap::logFall(void)
{	printlr("logging fall objects");
	printlr("%i objects",objfill);

	u32 id=0;
	for(u32 n=0;n<objfill;id++)
	{	struct fallObj * o = &obj[id];
		if(o->state)
		{	printlr("** %i .. state %i .. color %i",id,o->state,o->color);
			printlr(" * size %ix%i .. pos %i.%i",o->sx,o->sy,o->px,o->py);
			printlr(" -------- %i",o->nb);
			for(u32 y=0;y<o->sy;y++)
			{	for(u32 x=0;x<o->sx;x++)
				{	u32 value = o->map[y+x*o->sy];
					if(value<0xf0)	printl("o ");
						else	printl(". ");
					
				}
				printl("\n");
			}
			printlr(" --------");

			n++;
		}
	}
}

void drillMap::deleteAndAddToFallObj(int x, int y)
{	if(x<0 || x>=sizex)  return;
	if(y<0 || y>=sizey) return;
	
	u32 value = array[y+x*sizey];

	if(value >= 0xf0) return; // already deleted, or empty..

	destruct(x,y); // destruct tiles..

	// now add the deleted block into a fall object
	
	u32 objId = 0;	// search for an empty fall object
	while(this->obj[objId].state) objId++;
	// compute map size
	u32 sx = colMax  -  colMin + 1;
	u32 sy = lineMax - lineMin + 1;
	// fill object info
	
	this->obj[objId].sx = sx;
	this->obj[objId].sy = sy;
	this->obj[objId].px =  colMin;
	this->obj[objId].py = lineMin;
	this->obj[objId].color = value>>4;
	this->obj[objId].nb = destructNb;
	this->obj[objId].lastTime[0] = tick;
	this->obj[objId].lastTime[1] = 0;

	u8 * map = (u8*)malloc(sx*sy);
	memset(map,0xf0,sx*sy);
	this->obj[objId].map = map;

	u8 * destructedPtr = destructList;

	for(u32 n=0;n<destructNb;n++)
	{	u32 xx = destructedPtr[0] - this->obj[objId].px;
		u32 yy = destructedPtr[1] - this->obj[objId].py;
		map[yy+xx*sy] = destructedPtr[2];
		destructedPtr += 4;
	}
	
	this->obj[objId].state = 1;
	this->objfill ++ ;
}
