
#include "../Gdl/Gdl.h" // the lib..

struct fallObj
{  	u32 sx,sy,px,py,nb,id;
	u32 subPy;
	u32 state; // 0:empty  1:rumble  2:fall
	u32 color;
	u8 *map;
	u32 lastTime[2];
	u32 rumble;
	
	u32 stopFallNb;
	u16 stopFall[16];
	u32 canDown;
	u32 parsed;
};

class drillMap
{  public:
	clDeep **tileset;
	void set(int x, int y, u32 value);

	drillMap(void);
	void logFall(void);
	void removeObj(struct fallObj *o);
	u32  tileSize;
	u32  getColor(int x, int y);
	void setColor(int x, int y, u32 value);
	u32  getStick(int x, int y);
	void setStick(int x, int y, u32 way, u32 value);
	u32  getValue(int x, int y);
	
	u32  isThereATile(int x, int y);
	u32  blockCanFall(int x, int y);

	u32  isOutOfMap(int x, int y);
	u32  isAnyBlockUnder(int x, int y);
	void update(void);

	void randomize(void);
	void showOne(int x, int y);
	void draw(void);
	void deleteThisBlock(int x, int y);
	void deleteAndAddToFallObj(int x, int y);	
	void drawAndUpdateObj(void);
	int sizex, sizey;

private:
	u8 array[4096];
	u8*arrayFill;
	
	u32 scrollx, scrolly;

	fallObj obj[1024];
	u32 objfill;
	
	u32 fallingBlockNb;
	u8 *fallingBlockParsed;
	u32 rIsFallObjFall(u32 id);

	u8  destructList[1024];	u32 destructNb;
	int lineMin, lineMax, colMin, colMax;

	u32  isAnyFallingBlocAt(u32 colon, u32 y);
	u32  isFallingBlocAt(u32 colon, u32 y);

	u32  canObjectFallDown(struct fallObj *o);
	u32  drillColide(struct fallObj *o1,struct fallObj *o2);
	void rBlockCanFall(int x, int y, u32*canFall);
	void deleteBlock(int x, int y);
	void updateTile(int x, int y);
	void searchForFallingBlock(u32 line);
	void destruct(int x, int y);
	void createFallList(struct fallObj * o);
	void downObject(struct fallObj * o);
};
